libdap::Constructor Class Referenceabstract

`#include <Constructor.h>`

Inheritance diagram for libdap::Constructor:

## Public Types

typedef stack< BaseType * > | btp_stack
typedef std::vector< BaseType * >::const_iterator | Vars_citer
typedef std::vector< BaseType * >::iterator | Vars_iter
typedef std::vector< BaseType * >::reverse_iterator | Vars_riter

## Public Member Functions

void | add_var (BaseType *bt, Part part=nil) override
void | add_var_nocopy (BaseType *bt, Part part=nil) override
unsigned int | buf2val (void **) override
| Reads the class data.
bool | check_semantics (string &msg, bool all=false) override
| Compare an object's current state with the semantics of its type.
virtual void | clear_local_data ()
void | compute_checksum (Crc32 &checksum) override
| include the data for this variable in the checksum DAP4 includes a checksum with every data response. This method adds the variable's data to that checksum.
virtual bool | d4_ops (BaseType *b, int op)
| Evaluator a relop for DAP4.
virtual string | dataset () const
| Returns the name of the dataset used to create this instance.
virtual void | del_var (const string &name)
| Remove an element from a Constructor.
virtual void | del_var (Vars_iter i)
| Delete the BaseType* and erase the iterator .
void | deserialize (D4StreamUnMarshaller &um, DMR &dmr) override
bool | deserialize (UnMarshaller &um, DDS *dds, bool reuse=false) override
| Receive data from the net.
void | dump (ostream &strm) const override
| dumps information about this object
int | element_count (bool leaves=false) override
| Count the members of constructor types.
std::string | FQN () const override
virtual BaseType * | get_ancestor ()
virtual AttrTable & | get_attr_table ()
virtual BaseType * | get_parent () const
BaseType * | get_var_index (int i)
Vars_iter | get_vars_iter (int i)
void | intern_data () override
| Read data into this variable.
void | intern_data (ConstraintEvaluator &eval, DDS &dds) override
virtual bool | is_constructor_type () const
| Returns true if the instance is a constructor (i.e., Structure, Sequence or Grid) type variable.
virtual bool | is_dap4 () const
bool | is_dap4_projected (std::vector< std::string > &inventory) override
virtual bool | is_in_selection ()
| Is this variable part of the current selection?
virtual bool | is_linear ()
| Check to see whether this variable can be printed simply.
virtual bool | is_simple_type () const
| Returns true if the instance is a numeric, string or URL type variable.
virtual bool | is_vector_type () const
| Returns true if the instance is a vector (i.e., array) type variable.
virtual int | length () const
| How many elements are in this variable? Uses -1 in places.
virtual int64_t | length_ll () const
| Get the number of elements in this variable This version of the function deprecates length() which is limited to 32-bit sizes. The field uses -1 as a sentinel value indicating that a Vector/Array holds no values yet (as opposed to zero values). For types not derived from Vector, there is always one element.
virtual string | name () const
| Returns the name of the class instance.
Constructor & | operator= (const Constructor &rhs)
virtual bool | ops (BaseType *b, int op)
| Evaluate relational operators.
void | print_dap4 (XMLWriter &xml, bool constrained=false) override
void | print_decl (FILE *out, string space=" ", bool print_semi=true, bool constraint_info=false, bool constrained=false) override
| Print an ASCII representation of the variable structure.
void | print_decl (ostream &out, string space=" ", bool print_semi=true, bool constraint_info=false, bool constrained=false) override
| Print an ASCII representation of the variable structure.
void | print_val (FILE *out, string space="", bool print_decl_p=true) override
| Prints the value of the variable.
void | print_val (ostream &out, string space="", bool print_decl_p=true) override
| Prints the value of the variable.
void | print_xml (FILE *out, string space=" ", bool constrained=false) override
void | print_xml (ostream &out, string space=" ", bool constrained=false) override
void | print_xml_writer (XMLWriter &xml, bool constrained=false) override
virtual BaseType * | ptr_duplicate ()=0
bool | read () override
| Read the elements of Constructor marked for transmission.
virtual bool | read_p ()
| Has this variable been read?
virtual bool | send_p ()
| Should this variable be sent?
bool | serialize (ConstraintEvaluator &eval, DDS &dds, Marshaller &m, bool ce_eval=true) override
| Move data to the net, then remove them from the object.
void | serialize (D4StreamMarshaller &m, DMR &dmr, bool filter=false) override
| Serialize a Constructor.
virtual void | set_attr_table (const AttrTable &at)
void | set_in_selection (bool state) override
| Set the in_selection property.
virtual void | set_is_dap4 (const bool v)
virtual void | set_length (int64_t)
| Set the number of elements for this variable. use -1 to indicate nothing set.
virtual void | set_length_ll (int64_t)
| Set the number of elements in this variable This version of the function deprecates set_length() which is limited to 32-bit sizes. The field uses -1 as a sentinel value indicating that the Vector/Array holds no values.
virtual void | set_name (const string &n)
| Sets the name of the class instance.
virtual void | set_parent (BaseType *parent)
void | set_read_p (bool state) override
| Set the 'read_p' property for the Constructor and its members.
void | set_send_p (bool state) override
virtual void | set_synthesized_p (bool state)
virtual void | set_type (const Type &t)
| Sets the type of the class instance.
void | set_var_index (BaseType *bt, int i)
| Set the ith element of d_vars to a variable object.
virtual bool | synthesized_p ()
virtual string | toString ()
void | transfer_attributes (AttrTable *at) override
virtual std::vector< BaseType * > * | transform_to_dap2 (AttrTable *parent_attr_table)
| DAP4 to DAP2 transform.
void | transform_to_dap4 (D4Group *root, Constructor *dest) override
| DAP2 to DAP4 transform.
virtual Type | type () const
| Returns the type of the class instance.
virtual string | type_name () const
| Returns the type of the class instance as a string.
unsigned int | val2buf (void *, bool) override
| Loads class data.
BaseType * | var (const string &n, btp_stack &s) override
BaseType * | var (const string &name, bool exact_match=true, btp_stack *s=nullptr) override
| btp_stack no longer needed; use back pointers (BaseType::get_parent())
Vars_iter | var_begin ()
Vars_iter | var_end ()
Vars_riter | var_rbegin ()
Vars_riter | var_rend ()
const vector< BaseType * > & | variables () const
unsigned int | width (bool constrained=false) const override
int64_t | width_ll (bool constrained=false) const override
| Get the width of the Constructor's fields.
virtual D4Attributes * | attributes ()
virtual void | set_attributes (D4Attributes *)
virtual void | set_attributes_nocopy (D4Attributes *)

## Static Public Member Functions

static AttrTable * | make_dropped_vars_attr_table (vector< BaseType * > *dropped_vars)

## Protected Member Functions

| Constructor (const Constructor &copy_from)
| Constructor (const string &name, const string &dataset, const Type &type, bool is_dap4=false)
| Constructor (const string &name, const Type &type, bool is_dap4=false)
void | m_duplicate (const BaseType &bt)
| Perform a deep copy.
BaseType * | m_exact_match (const string &name, btp_stack *s=nullptr)
BaseType * | m_leaf_match (const string &name, btp_stack *s=nullptr)

## Protected Attributes

std::vector< BaseType * > | d_vars

## Detailed Description

Common methods for all constructor types.

Definition at line 43 of file Constructor.h.

## Member Typedef Documentation

## btp_stack

typedef stack<BaseType *> libdap::BaseType::btp_stack

inherited

Definition at line 151 of file BaseType.h.

## Vars_citer

typedef std::vector<BaseType*>::const_iterator libdap::Constructor::Vars_citer

Definition at line 64 of file Constructor.h.

## Vars_iter

typedef std::vector<BaseType*>::iterator libdap::Constructor::Vars_iter

Definition at line 65 of file Constructor.h.

## Vars_riter

typedef std::vector<BaseType*>::reverse_iterator libdap::Constructor::Vars_riter

Definition at line 66 of file Constructor.h.

## Constructor & Destructor Documentation

## Constructor() [1/3]

libdap::Constructor::Constructor | ( | const string & | name,
|  | const Type & | type,
|  | bool | is_dap4 = `false`
| ) |  |

inline protected

Definition at line 54 of file Constructor.h.

## Constructor() [2/3]

libdap::Constructor::Constructor | ( | const string & | name,
|  | const string & | dataset,
|  | const Type & | type,
|  | bool | is_dap4 = `false`
| ) |  |

inline protected

Definition at line 56 of file Constructor.h.

## Constructor() [3/3]

libdap::Constructor::Constructor | ( | const Constructor & | copy_from | ) |

inline protected

Definition at line 59 of file Constructor.h.

## ~Constructor()

libdap::Constructor::~Constructor | ( |  | ) |

inline override

Definition at line 70 of file Constructor.h.

## Member Function Documentation

## add_var()

void libdap::Constructor::add_var | ( | BaseType * | bt,
|  | Part | part = `nil`
| ) |  |

override virtual

Adds an element to a Constructor.

Parameters

  bt | A pointer to the variable to add to this Constructor.
  part | Not used by this class, defaults to nil

Reimplemented from libdap::BaseType.

Reimplemented in libdap::Grid.

Definition at line 375 of file Constructor.cc.

## add_var_nocopy()

void libdap::Constructor::add_var_nocopy | ( | BaseType * | bt,
|  | Part | part = `nil`
| ) |  |

override virtual

Adds an element to a Constructor.

Parameters

  bt | A pointer to thee variable to add to this Constructor.
  part | Not used by this class, defaults to nil

Reimplemented from libdap::BaseType.

Reimplemented in libdap::Grid.

Definition at line 395 of file Constructor.cc.

## attributes()

D4Attributes * libdap::BaseType::attributes | ( |  | ) |

virtual inherited

DAP4 Attribute methods

Definition at line 596 of file BaseType.cc.

## buf2val()

unsigned int libdap::Constructor::buf2val | ( | void ** | val | ) |

inline override virtual

Reads the class data.

Reads the class data into the memory referenced by val. The caller should either allocate enough storage to val to hold the class data or set `*val` to null. If *val is NULL, memory will be allocated by this function with `new()`. If the memory is allocated this way, the caller is responsible for deallocating that memory. Array and values for simple types are stored as C would store an array.

Deprecated:
  Use value() in the leaf classes.

Parameters

  val | A pointer to a pointer to the memory into which the class data will be copied. If the value pointed to is NULL, memory will be allocated to hold the data, and the pointer value modified accordingly. The calling program is responsible for deallocating the memory references by this pointer.

Returns
  The size (in bytes) of the information copied to val.

Implements libdap::BaseType.

Definition at line 142 of file Constructor.h.

## check_semantics()

bool libdap::Constructor::check_semantics | ( | string & | msg,
|  | bool | all = `false`
| ) |  |

override virtual

Compare an object's current state with the semantics of its type.

This function checks the class instance for internal consistency. This is important to check for complex constructor classes. For BaseType, an object is semantically correct if it has both a non-null name and type.

For example, an Int32 instance would return FALSE if it had no name or no type defined. A Grid instance might return FALSE for more complex reasons, such as having Map arrays of the wrong size or shape.

This function is used by the DDS class, and will rarely, if ever, be explicitly called by a DODS application program. A variable must pass this test before it is sent, but there may be many other stages in a retrieve operation where it would fail.

Returns
  Returns FALSE when the current state violates some aspect of the type semantics, TRUE otherwise.

Parameters

  msg | A returned string, containing a message indicating the source of any problem.
  all | For complex constructor types (Grid, Sequence, Structure), this flag indicates whether to check the semantics of the member variables, too.

See also
  DDS::check_semantics

Reimplemented from libdap::BaseType.

Reimplemented in libdap::Grid.

Definition at line 712 of file Constructor.cc.

## clear_local_data()

virtual void libdap::BaseType::clear_local_data | ( |  | ) |

inline virtual inherited

Remove any read or set data in the private data of the variable, setting read_p() to false. Used to clear any dynamically allocated storage that holds (potentially large) data. For the simple types, this no-op version is all that's needed. Vector and some other classes define a special version and have serialize() implementations that call it to free data as soon as possible after sending it.

Note
  Added 7/5/15 jhrg
  Any specialization of this should make sure to reset the read_p property.

Reimplemented in libdap::D4Opaque, libdap::Sequence, libdap::D4Sequence, and libdap::Vector.

Definition at line 181 of file BaseType.h.

## compute_checksum()

void libdap::Constructor::compute_checksum | ( | Crc32 & | checksum | ) |

override virtual

include the data for this variable in the checksum DAP4 includes a checksum with every data response. This method adds the variable's data to that checksum.

Parameters

  checksum | A Crc32 instance that holds the current checksum.

Implements libdap::BaseType.

Definition at line 519 of file Constructor.cc.

## d4_ops()

bool libdap::BaseType::d4_ops | ( | BaseType * | b,
|  | int | op
| ) |  |

virtual inherited

Evaluator a relop for DAP4.

This method is used by the filter expression evaluation code in DAP4. Each of the 'data type' classes that support relops must overload this method. In an expression of the form arg1 op arg2, this object is arg1, the parameter 'b' is arg2 and op is the relational operator.

Note
  I used the same relop codes for DAP4 as in the DAP2 parser/scanner which makes for some coupling between them, but cuts way down on the duplication of the evaluator logic, which is somewhat involved.

Parameters

  b | The second argument in the relational expression
  op | The infix relational operator

Returns
  True if the expression is true, False otherwise.

Reimplemented in libdap::Byte, libdap::Float32, libdap::Float64, libdap::Int16, libdap::Int32, libdap::Int64, libdap::Int8, libdap::Str, and libdap::UInt64.

Definition at line 1288 of file BaseType.cc.

## dataset()

string libdap::BaseType::dataset | ( |  | ) | const

virtual inherited

Returns the name of the dataset used to create this instance.

A dataset from which the data is to be read. The meaning of this string will vary among different types of data sources. It may be the name of a data file or an identifier used to read data from a relational database.

Definition at line 355 of file BaseType.cc.

## del_var() [1/2]

void libdap::Constructor::del_var | ( | const string & | n | ) |

virtual

Remove an element from a Constructor.

Note
  New version. There is a subtle change in that this version will remove all variables in this Constructor with name 'n' while the old version would just remove the first variable.

Parameters

  n | name of the variable to remove

Definition at line 416 of file Constructor.cc.

## del_var() [2/2]

void libdap::Constructor::del_var | ( | Vars_iter | i | ) |

virtual

Delete the BaseType* and erase the iterator .

Note
  It is OK to call this with an iterator that points to nullptr.

Parameters

  i | The iterator that points to the BaseType.

Definition at line 430 of file Constructor.cc.

## deserialize() [1/2]

void libdap::Constructor::deserialize | ( | D4StreamUnMarshaller & | um,
|  | DMR & | dmr
| ) |  |

override virtual

The DAP4 deserialization method.

Parameters

  um |
  dmr |

Exceptions

  Error | or InternalErr

Reimplemented from libdap::BaseType.

Reimplemented in libdap::D4Group, and libdap::D4Sequence.

Definition at line 572 of file Constructor.cc.

## deserialize() [2/2]

bool libdap::Constructor::deserialize | ( | UnMarshaller & | um,
|  | DDS * | dds,
|  | bool | reuse = `false`
| ) |  |

override virtual

Receive data from the net.

Receives data from the network connection identified by the `source` parameter. The data is put into the class data buffer according to the input `dds`.

This function is only used on the client side of the DODS client/server connection.

Parameters

  um | An UnMarshaller that knows how to deserialize data types
  dds | The Data Descriptor Structure object corresponding to this dataset. See The DODS User Manual for information about this structure. This would have been received from the server in an earlier transmission.
  reuse | A boolean value, indicating whether the class internal data storage can be reused or not. If this argument is TRUE, the class buffer is assumed to be large enough to hold the incoming data, and it is not reallocated. If FALSE, new storage is allocated. If the internal buffer has not been allocated at all, this argument has no effect.

Returns
  Always returns TRUE.

Exceptions

  Error | when a problem reading from the UnMarshaller is found.

See also
  DDS

Reimplemented from libdap::BaseType.

Reimplemented in libdap::D4Sequence, and libdap::Sequence.

Definition at line 509 of file Constructor.cc.

## dump()

void libdap::Constructor::dump | ( | ostream & | strm | ) | const

override virtual

dumps information about this object

Displays the pointer value of this instance and information about this instance.

Parameters

  strm | C++ i/o stream to dump the information to

Returns
  void

Reimplemented from libdap::BaseType.

Reimplemented in libdap::Grid, libdap::Sequence, libdap::Structure, and libdap::D4Sequence.

Definition at line 845 of file Constructor.cc.

## element_count()

int libdap::Constructor::element_count | ( | bool | leaves = `false` | ) |

override virtual

Count the members of constructor types.

Return a count of the total number of variables in this variable. This is used to count the number of variables held by a constructor variable - for simple type and vector variables it always returns 1.

For compound data types, there are two ways to count members. You can count the members, or you can count the simple members and add that to the count of the compound members. For example, if a Structure contains an Int32 and another Structure that itself contains two Int32 members, the element count of the top-level structure could be two (one Int32 and one Structure) or three (one Int32 by itself and two Int32's in the subsidiary Structure). Use the leaves parameter to control which kind of counting you desire.

Returns
  Returns 1 for simple types. For compound members, the count depends on the leaves argument.

Parameters

  leaves | This parameter is only relevant if the object contains other compound data types. If FALSE, the function counts only the data variables mentioned in the object's declaration. If TRUE, it counts the simple members, and adds that to the sum of the counts for the compound members. This parameter has no effect for simple type variables.

Reimplemented from libdap::BaseType.

Definition at line 116 of file Constructor.cc.

## FQN()

string libdap::Constructor::FQN | ( |  | ) | const

override virtual

Return the FQN for this variable. This will include the D4 Group component of the name.

Returns
  The FQN in a string

Reimplemented from libdap::BaseType.

Reimplemented in libdap::D4Group.

Definition at line 103 of file Constructor.cc.

## get_ancestor()

BaseType * libdap::BaseType::get_ancestor | ( |  | ) |

virtual inherited

Definition at line 754 of file BaseType.cc.

## get_attr_table()

AttrTable & libdap::BaseType::get_attr_table | ( |  | ) |

virtual inherited

Get this variable's AttrTable. It's generally a bad idea to return a reference to a contained object, but in this case it seems that building an interface inside BaseType is overkill.

Use the AttrTable methods to manipulate the table.

Definition at line 579 of file BaseType.cc.

## get_parent()

BaseType * libdap::BaseType::get_parent | ( |  | ) | const

virtual inherited

Return a pointer to the Constructor or Vector which holds (contains) this variable. If this variable is at the top level, this method returns null.

Returns
  A BaseType pointer to the variable's parent.

Definition at line 748 of file BaseType.cc.

## get_var_index()

BaseType * libdap::Constructor::get_var_index | ( | int | i | ) |

Return the BaseType pointer for the ith variable.

Parameters

  i | This index

Returns
  The corresponding BaseType*.

Definition at line 338 of file Constructor.cc.

## get_vars_iter()

Constructor::Vars_iter libdap::Constructor::get_vars_iter | ( | int | i | ) |

Return the iterator for the ith variable.

Parameters

  i | the index

Returns
  The corresponding Vars_iter

Definition at line 329 of file Constructor.cc.

## intern_data() [1/2]

void libdap::Constructor::intern_data | ( |  | ) |

override virtual

Read data into this variable.

Parameters

  eval | Evaluator for a constraint expression
  dmr | DMR for the whole dataset

Reimplemented from libdap::BaseType.

Reimplemented in libdap::D4Group, and libdap::D4Sequence.

Definition at line 525 of file Constructor.cc.

## intern_data() [2/2]

void libdap::Constructor::intern_data | ( | ConstraintEvaluator & | eval,
|  | DDS & | dds
| ) |  |

override virtual

Similar to using serialize() and deserialize() together in one object. Data are read as for serialize and those values are stored in the objects as deserialize() does but does not write and then read data to/from a stream.

This method is defined by the various data type classes. It calls the read() abstract method. Unlike serialize(), this method does not clear the memory use to hold the data values, so the caller should make sure to delete the DDS or the variable as soon as possible.

Note
  This version of the method is specific to DAP2. It will throw an exception if called on a variable where the is_dap4 property is true.

Parameters

  eval | Use this as the constraint expression evaluator.
  dds | The Data Descriptor Structure object corresponding to this dataset. See The DODS User Manual for information about this structure.

Reimplemented from libdap::BaseType.

Reimplemented in libdap::D4Sequence, and libdap::Sequence.

Definition at line 462 of file Constructor.cc.

## is_constructor_type()

bool libdap::BaseType::is_constructor_type | ( |  | ) | const

virtual inherited

Returns true if the instance is a constructor (i.e., Structure, Sequence or Grid) type variable.

Returns
  True if the instance is a Structure, Sequence or Grid, False otherwise.

Definition at line 409 of file BaseType.cc.

## is_dap4()

virtual bool libdap::BaseType::is_dap4 | ( |  | ) | const

inline virtual inherited

Definition at line 183 of file BaseType.h.

## is_dap4_projected()

bool libdap::Constructor::is_dap4_projected | ( | std::vector< std::string > & | inventory | ) |

override virtual

When send_p() is true and the attributes or variables contain dap4 data types then a description of the instance is added to the inventory and true is returned.

Parameters

  inventory | is a value-result parameter

Returns
  True when send_p() is true and this object contains dap4 types variables or attributes, false otherwise

Reimplemented from libdap::BaseType.

Reimplemented in libdap::D4Group.

Definition at line 823 of file Constructor.cc.

## is_in_selection()

bool libdap::BaseType::is_in_selection | ( |  | ) |

virtual inherited

Is this variable part of the current selection?

Does this variable appear in either the selection part or as a function argument in the current constrain expression. If this property is set (true) then implementations of the read() method should read this variable.

Note
  This method does not check, nor does it know about the semantics of, string arguments passed to functions. Those functions might include variable names in strings; they are responsible for reading those variables. See the grid (func_grid_select()) for an example.

See also
  BaseType::read()

Definition at line 700 of file BaseType.cc.

## is_linear()

bool libdap::Constructor::is_linear | ( |  | ) |

virtual

Check to see whether this variable can be printed simply.

True if the instance can be flattened and printed as a single table of values. For Arrays and Grids this is always false. For Structures and Sequences the conditions are more complex. The implementation provided by this class always returns false. Other classes should override this implementation.

Returns
  True if the instance can be printed as a single table of values, false otherwise.

Reimplemented in libdap::Sequence, and libdap::Structure.

Definition at line 741 of file Constructor.cc.

## is_simple_type()

bool libdap::BaseType::is_simple_type | ( |  | ) | const

virtual inherited

Returns true if the instance is a numeric, string or URL type variable.

Returns
  True if the instance is a scalar numeric, String or URL variable, False otherwise. Arrays (even of simple types) return False.

See also
  is_vector_type()

Definition at line 390 of file BaseType.cc.

## is_vector_type()

bool libdap::BaseType::is_vector_type | ( |  | ) | const

virtual inherited

Returns true if the instance is a vector (i.e., array) type variable.

Returns
  True if the instance is an Array, False otherwise.

Definition at line 399 of file BaseType.cc.

## length()

virtual int libdap::BaseType::length | ( |  | ) | const

inline virtual inherited

How many elements are in this variable? Uses -1 in places.

Returns
  The number of elements; 1 for scalars

Deprecated:
  Use length_ll() instead

Reimplemented in libdap::D4Opaque, libdap::Sequence, libdap::D4Sequence, libdap::Str, and libdap::Vector.

Definition at line 209 of file BaseType.h.

## length_ll()

virtual int64_t libdap::BaseType::length_ll | ( |  | ) | const

inline virtual inherited

Get the number of elements in this variable This version of the function deprecates length() which is limited to 32-bit sizes. The field uses -1 as a sentinel value indicating that a Vector/Array holds no values yet (as opposed to zero values). For types not derived from Vector, there is always one element.

Returns
  The number of elements in this variable

Reimplemented in libdap::Str, and libdap::Vector.

Definition at line 218 of file BaseType.h.

## m_duplicate()

void libdap::BaseType::m_duplicate | ( | const BaseType & | bt | ) |

protected inherited

Perform a deep copy.

Perform a deep copy. Copies the values of bt into `*this`. Pointers are dereferenced and their values are copied into a newly allocated instance.

Parameters

  bt | The source object.

Definition at line 86 of file BaseType.cc.

## m_exact_match()

BaseType * libdap::Constructor::m_exact_match | ( | const string & | name,
|  | btp_stack * | s = `nullptr`
| ) |  |

protected

Definition at line 262 of file Constructor.cc.

## m_leaf_match()

BaseType * libdap::Constructor::m_leaf_match | ( | const string & | name,
|  | btp_stack * | s = `nullptr`
| ) |  |

protected

Definition at line 237 of file Constructor.cc.

## make_dropped_vars_attr_table()

AttrTable * libdap::Constructor::make_dropped_vars_attr_table | ( | vector< BaseType * > * | dropped_vars | ) |

static

Definition at line 774 of file Constructor.cc.

## name()

string libdap::BaseType::name | ( |  | ) | const

virtual inherited

Returns the name of the class instance.

Definition at line 317 of file BaseType.cc.

## operator=()

Constructor & libdap::Constructor::operator= | ( | const Constructor & | rhs | ) |

inline

Definition at line 75 of file Constructor.h.

## ops()

bool libdap::BaseType::ops | ( | BaseType * | b,
|  | int | op
| ) |  |

virtual inherited

Evaluate relational operators.

This method contains the relational operators used by the constraint expression evaluator in the DDS class. Each class that wants to be able to evaluate relational expressions must overload this function. The implementation in BaseType throws an InternalErr exception. The DAP library classes Byte, ..., Url provide specializations of this method. It is not meaningful for classes such as Array because relational expressions using Array are not supported.

The op argument refers to a table generated by bison from the constraint expression parser. Use statements like the following to correctly interpret its value:

    switch (op) {
        case EQUAL: return i1 == i2;
        case NOT_EQUAL: return i1 != i2;
        case GREATER: return i1 > i2;
        case GREATER_EQL: return i1 >= i2;
        case LESS: return i1 < i2;
        case LESS_EQL: return i1 <= i2;
        case REGEXP: throw Error("Regular expressions are not supported for integer values");
        default: throw Error("Unknown operator");
    }

This function is used by the constraint expression evaluator.

Parameters

  b | Compare the value of this instance with b.
  op | An integer index indicating which relational operator is implied. Choose one from the following: `EQUAL`, `NOT_EQUAL`, `GREATER`, `GREATER_EQL`, `LESS`, `LESS_EQL`, and `REGEXP`.

Returns
  The boolean value of the comparison.

See also
  BaseType::d4_ops(BaseType *, int)

Reimplemented in libdap::D4Opaque, libdap::Byte, libdap::D4Enum, libdap::Float32, libdap::Float64, libdap::Int16, libdap::Int32, libdap::Int64, libdap::Int8, libdap::Str, libdap::UInt16, libdap::UInt32, and libdap::UInt64.

Definition at line 1262 of file BaseType.cc.

## print_dap4()

void libdap::Constructor::print_dap4 | ( | XMLWriter & | xml,
|  | bool | constrained = `false`
| ) |  |

override virtual

Write the DAP4 XML representation for this variable. This method is used to build the DAP4 DMR response object.

Parameters

  xml | An XMLWriter that will do the serialization
  constrained | True if the response should show the variables subject to the current constraint expression.

Reimplemented from libdap::BaseType.

Reimplemented in libdap::D4Group.

Definition at line 689 of file Constructor.cc.

## print_decl() [1/2]

void libdap::Constructor::print_decl | ( | FILE * | out,
|  | string | space = `" "`,
|  | bool | print_semi = `true`,
|  | bool | constraint_info = `false`,
|  | bool | constrained = `false`
| ) |  |

override virtual

Print an ASCII representation of the variable structure.

Write the variable's declaration in a C-style syntax. This function is used to create textual representation of the Data Descriptor Structure (DDS). See The DODS User Manual for information about this structure.

A simple array declaration might look like this:

    Float64 lat[lat = 180];

While a more complex declaration (for a Grid, in this case), would look like this:

    Grid {
    ARRAY:
    Int32 sst[time = 404][lat = 180][lon = 360];
    MAPS:
    Float64 time[time = 404];
    Float64 lat[lat = 180];
    Float64 lon[lon = 360];
    } sst;

Parameters

  out | The output stream on which to print the declaration.
  space | Each line of the declaration will begin with the characters in this string. Usually used for leading spaces.
  print_semi | A boolean value indicating whether to print a semicolon at the end of the declaration.
  constraint_info | A boolean value indicating whether constraint information is to be printed with the declaration. If the value of this parameter is TRUE, `print_decl()` prints the value of the variable's `send_p()` flag after the declaration.
  constrained | If this boolean value is TRUE, the variable's declaration is only printed if is the `send_p()` flag is TRUE. If a constraint expression is in place, and this variable is not requested, the `send_p()` flag is FALSE.

See also
  DDS
  DDS::CE

Reimplemented from libdap::BaseType.

Reimplemented in libdap::Grid, and libdap::D4Group.

Definition at line 580 of file Constructor.cc.

## print_decl() [2/2]

void libdap::Constructor::print_decl | ( | ostream & | out,
|  | string | space = `" "`,
|  | bool | print_semi = `true`,
|  | bool | constraint_info = `false`,
|  | bool | constrained = `false`
| ) |  |

override virtual

Print an ASCII representation of the variable structure.

Write the variable's declaration in a C-style syntax. This function is used to create textual representation of the Data Descriptor Structure (DDS). See The DODS User Manual for information about this structure.

A simple array declaration might look like this:

    Float64 lat[lat = 180];

While a more complex declaration (for a Grid, in this case), would look like this:

    Grid {
    ARRAY:
    Int32 sst[time = 404][lat = 180][lon = 360];
    MAPS:
    Float64 time[time = 404];
    Float64 lat[lat = 180];
    Float64 lon[lon = 360];
    } sst;

Parameters

  out | The output stream on which to print the declaration.
  space | Each line of the declaration will begin with the characters in this string. Usually used for leading spaces.
  print_semi | A boolean value indicating whether to print a semicolon at the end of the declaration.
  constraint_info | A boolean value indicating whether constraint information is to be printed with the declaration. If the value of this parameter is TRUE, `print_decl()` prints the value of the variable's `send_p()` flag after the declaration.
  constrained | If this boolean value is TRUE, the variable's declaration is only printed if is the `send_p()` flag is TRUE. If a constraint expression is in place, and this variable is not requested, the `send_p()` flag is FALSE.

See also
  DDS
  DDS::CE

Reimplemented from libdap::BaseType.

Reimplemented in libdap::Grid, and libdap::D4Group.

Definition at line 588 of file Constructor.cc.

## print_val() [1/2]

void libdap::Constructor::print_val | ( | FILE * | out,
|  | string | space = `""`,
|  | bool | print_decl_p = `true`
| ) |  |

override virtual

Prints the value of the variable.

Prints the value of the variable, with its declaration. This function is primarily intended for debugging DODS applications. However, it can be overloaded and used to do some useful things. Take a look at the asciival and writeval clients, both of which overload this to output the values of variables in different ways.

Parameters

  out | The output stream on which to print the value.
  space | This value is passed to the print_decl() function, and controls the leading spaces of the output.
  print_decl_p | A boolean value controlling whether the variable declaration is printed as well as the value.

Prints the value of the variable, with its declaration. This function is primarily intended for debugging DODS applications. However, it can be overloaded and used to do some useful things. Take a look at the asciival and writeval clients, both of which overload this to output the values of variables in different ways.

Parameters

  out | The output stream on which to print the value.
  space | This value is passed to the print_decl() function, and controls the leading spaces of the output.
  print_decl_p | A boolean value controlling whether the variable declaration is printed as well as the value.

Reimplemented from libdap::BaseType.

Reimplemented in libdap::Grid, libdap::Sequence, and libdap::D4Group.

Definition at line 611 of file Constructor.cc.

## print_val() [2/2]

void libdap::Constructor::print_val | ( | ostream & | out,
|  | string | space = `""`,
|  | bool | print_decl_p = `true`
| ) |  |

override virtual

Prints the value of the variable.

Prints the value of the variable, with its declaration. This function is primarily intended for debugging DODS applications. However, it can be overloaded and used to do some useful things. Take a look at the asciival and writeval clients, both of which overload this to output the values of variables in different ways.

Parameters

  out | The output ostream on which to print the value.
  space | This value is passed to the print_decl() function, and controls the leading spaces of the output.
  print_decl_p | A boolean value controlling whether the variable declaration is printed as well as the value.

Implements libdap::BaseType.

Reimplemented in libdap::Grid, libdap::Sequence, libdap::D4Group, and libdap::D4Sequence.

Definition at line 619 of file Constructor.cc.

## print_xml() [1/2]

void libdap::Constructor::print_xml | ( | FILE * | out,
|  | string | space = `" "`,
|  | bool | constrained = `false`
| ) |  |

override virtual

Deprecated:

Reimplemented from libdap::BaseType.

Reimplemented in libdap::Grid.

Definition at line 641 of file Constructor.cc.

## print_xml() [2/2]

void libdap::Constructor::print_xml | ( | ostream & | out,
|  | string | space = `" "`,
|  | bool | constrained = `false`
| ) |  |

override virtual

Deprecated:

Reimplemented from libdap::BaseType.

Reimplemented in libdap::Grid.

Definition at line 652 of file Constructor.cc.

## print_xml_writer()

void libdap::Constructor::print_xml_writer | ( | XMLWriter & | xml,
|  | bool | constrained = `false`
| ) |  |

override virtual

Write the XML representation of this variable. This method is used to build the DDX XML response.

Parameters

  out | Destination output stream
  space | Use this to indent child declarations. Default is "".
  constrained | If true, only print this if it's part part of the current projection. Default is False.

Reimplemented from libdap::BaseType.

Reimplemented in libdap::Grid.

Definition at line 660 of file Constructor.cc.

## ptr_duplicate()

virtual BaseType * libdap::BaseType::ptr_duplicate | ( |  | ) |

pure virtual inherited

Clone this instance. Allocate a new instance and copy `*this` into it. This method must perform a deep copy.

    @note This method should \e not copy data values, but must copy all
    other fields in the object.

Returns
  A newly allocated copy of `this`.

Implemented in libdap::Grid, libdap::Sequence, libdap::Structure, libdap::Url, libdap::Array, libdap::Byte, libdap::D4Enum, libdap::D4Group, libdap::D4Opaque, libdap::D4Sequence, libdap::Float32, libdap::Float64, libdap::Int16, libdap::Int32, libdap::Int64, libdap::Int8, libdap::Str, libdap::UInt16, libdap::UInt32, and libdap::UInt64.

## read()

bool libdap::Constructor::read | ( |  | ) |

override virtual

Read the elements of Constructor marked for transmission.

Iterate over the top level members of the Constructor and read all of them that have the 'send_p' property set to true. Assume the read() methods correctly set the 'read_p' property. Once done, set 'read_p' for the Constructor itself (but not for the members, that is left up to their individual read() methods).

Returns
  returns false; the return value is a relic.

Reimplemented from libdap::BaseType.

Definition at line 447 of file Constructor.cc.

## read_p()

bool libdap::BaseType::read_p | ( |  | ) |

virtual inherited

Has this variable been read?

Returns true if the value(s) for this variable have been read from the data source, otherwise returns false. This method is used to determine when values need to be read using the read() method. When read_p() returns true, this library assumes that buf2val() (and other methods such as get_vec()) can be used to access the value(s) of a variable.

Returns
  True if the variable's value(s) have been read, false otherwise.

Definition at line 477 of file BaseType.cc.

## send_p()

bool libdap::BaseType::send_p | ( |  | ) |

virtual inherited

Should this variable be sent?

Returns the state of the `send_p` property. If true, this variable should be sent to the client, if false, it should not. If no constraint expression (CE) has been evaluated, this property is true for all variables in a data source (i.e., for all the variables listed in a DDS). If a CE has been evaluated, this property is true only for those variables listed in the projection part of the CE.

Returns
  True if the variable should be sent to the client, false otherwise.

Definition at line 551 of file BaseType.cc.

## serialize() [1/2]

bool libdap::Constructor::serialize | ( | ConstraintEvaluator & | eval,
|  | DDS & | dds,
|  | Marshaller & | m,
|  | bool | ce_eval = `true`
| ) |  |

override virtual

Move data to the net, then remove them from the object.

Sends the data from the indicated (local) dataset through the connection identified by the Marshaller parameter. If the data is not already incorporated into the DDS object, read the data from the dataset. Once the data are sent (written to the Marshaller), they are deleted from the object and the object state is reset so that they will be read again if the read() method is called.

This function is only used on the server side of the client/server connection, and is generally only called from the ResponseBuilder functions. It has no BaseType implementation; each datatype child class supplies its own implementation.

Parameters

  eval | Use this as the constraint expression evaluator.
  dds | The Data Descriptor Structure object corresponding to this dataset. See The DODS User Manual for information about this structure.
  m | A marshaller used to serialize data types
  ce_eval | A boolean value indicating whether to evaluate the DODS constraint expression that may accompany this dataset. The constraint expression is stored in the dds.

Returns
  This method always returns true. Older versions used the return value to signal success or failure.

Note
  We changed the default behavior of this method so that it calls BaseType::clear_local_data() once the values are sent. This, combined with the behavior that read() is called by this method just before data are sent, means that data for any given variable remain in memory for the shortest time possible. Furthermore, since variables are serialized one at a time, no more than one variable's data will be in memory at any given time when using the default behavior. Some code - code that uses intern_data() or server functions - might alter this default behavior. Only Array (i.e. Vector), Sequence, D4Sequence and D4Opaque types actually hold data in dynamically allocated memory, so sonly those types have the new/changed behavior. This change was made on 7/5/15.

Exceptions

  InternalErr. |
  Error. |

See also
  DDS

Reimplemented from libdap::BaseType.

Reimplemented in libdap::D4Sequence, and libdap::Sequence.

Definition at line 478 of file Constructor.cc.

## serialize() [2/2]

void libdap::Constructor::serialize | ( | D4StreamMarshaller & | m,
|  | DMR & | dmr,
|  | bool | filter = `false`
| ) |  |

override virtual

Serialize a Constructor.

Todo:
  See notebook for 8/21/14

Parameters

  m |
  dmr | Unused
  eval | Unused
  filter | Unused

Exceptions

  Error | is thrown if the value needs to be read and that operation fails.

Reimplemented from libdap::BaseType.

Reimplemented in libdap::D4Group, and libdap::D4Sequence.

Definition at line 549 of file Constructor.cc.

## set_attr_table()

void libdap::BaseType::set_attr_table | ( | const AttrTable & | at | ) |

virtual inherited

Set this variable's attribute table.

Parameters

  at | Source of the attributes.

Definition at line 587 of file BaseType.cc.

## set_attributes()

void libdap::BaseType::set_attributes | ( | D4Attributes * | attrs | ) |

virtual inherited

Definition at line 603 of file BaseType.cc.

## set_attributes_nocopy()

void libdap::BaseType::set_attributes_nocopy | ( | D4Attributes * | attrs | ) |

virtual inherited

Definition at line 609 of file BaseType.cc.

## set_in_selection()

void libdap::Constructor::set_in_selection | ( | bool | state | ) |

override virtual

Set the in_selection property.

Set the in_selection property for this variable and all of its children.

Parameters

  state | Set the property value to state.

Reimplemented from libdap::BaseType.

Definition at line 752 of file Constructor.cc.

## set_is_dap4()

virtual void libdap::BaseType::set_is_dap4 | ( | const bool | v | ) |

inline virtual inherited

Definition at line 184 of file BaseType.h.

## set_length()

virtual void libdap::BaseType::set_length | ( | int64_t |  | ) |

inline virtual inherited

Set the number of elements for this variable. use -1 to indicate nothing set.

See also
  Vector

Parameters

  l | The number of elements

Deprecated:
  Use set_length_ll() instead

Reimplemented in libdap::D4Sequence, and libdap::Vector.

Definition at line 226 of file BaseType.h.

## set_length_ll()

virtual void libdap::BaseType::set_length_ll | ( | int64_t |  | ) |

inline virtual inherited

Set the number of elements in this variable This version of the function deprecates set_length() which is limited to 32-bit sizes. The field uses -1 as a sentinel value indicating that the Vector/Array holds no values.

Parameters

  l | The number of elements in the variable

Reimplemented in libdap::Vector.

Definition at line 234 of file BaseType.h.

## set_name()

void libdap::BaseType::set_name | ( | const string & | n | ) |

virtual inherited

Sets the name of the class instance.

Reimplemented in libdap::Vector.

Definition at line 341 of file BaseType.cc.

## set_parent()

void libdap::BaseType::set_parent | ( | BaseType * | parent | ) |

virtual inherited

Set the `parent` property for this variable.

Note
  Added ability to set parent to null. 10/19/12 jhrg

Parameters

  parent | Pointer to the Constructor of Vector parent variable or null if the variable has no parent (if it is at the top-level of a DAP2/3 DDS).

Exceptions

  InternalErr | thrown if called with anything other than a Constructor, Vector or Null.

Definition at line 730 of file BaseType.cc.

## set_read_p()

void libdap::Constructor::set_read_p | ( | bool | state | ) |

override virtual

Set the 'read_p' property for the Constructor and its members.

This method sets read_p for all of the Constructor. The read() method is much more selective and only sets read_p for the Constructor itself, leaving the value of the property of the members up to their read() methods. Calling this with false will clear the property of all the member variables.

Parameters

  state | Set the read_p property to this state.

Reimplemented from libdap::BaseType.

Reimplemented in libdap::D4Group.

Definition at line 151 of file Constructor.cc.

## set_send_p()

void libdap::Constructor::set_send_p | ( | bool | state | ) |

override virtual

Sets the value of the `send_p` flag. This function is meant to be called from within the constraint evaluator of other code which determines that this variable should be returned to the client. Data are ready to be sent when both the `d_is_send` and `d_is_read` flags are set to TRUE.

Parameters

  state | The logical state to set the `send_p` flag.

Reimplemented from libdap::BaseType.

Reimplemented in libdap::D4Group.

Definition at line 130 of file Constructor.cc.

## set_synthesized_p()

void libdap::BaseType::set_synthesized_p | ( | bool | state | ) |

virtual inherited

Set the synthesized flag. Before setting this flag be sure to set the `read_p()` state. Once this flag is set you cannot alter the state of the `read_p` flag!

See also
  synthesized_p()

Definition at line 460 of file BaseType.cc.

## set_type()

void libdap::BaseType::set_type | ( | const Type & | t | ) |

virtual inherited

Sets the type of the class instance.

Definition at line 369 of file BaseType.cc.

## set_var_index()

void libdap::Constructor::set_var_index | ( | BaseType * | bt,
|  | int | i
| ) |  |

Set the ith element of d_vars to a variable object.

Note
  This method only sets the ith element to a BaseType object. The user should be responsible to release or allocate the resource properly. Use this method cautionally.

Parameters

  bt | A pointer to the variable that is assigned to the ith element.
  i | The index of the variable to be set.

Definition at line 352 of file Constructor.cc.

## synthesized_p()

bool libdap::BaseType::synthesized_p | ( |  | ) |

virtual inherited

Returns true if the variable is a synthesized variable. A synthesized variable is one that is added to the dataset by the server (usually with a ‘projection function’.

Definition at line 449 of file BaseType.cc.

## toString()

string libdap::BaseType::toString | ( |  | ) |

virtual inherited

Write out the object's internal fields in a string. To be used for debugging when regular inspection w/ddd or gdb isn't enough.

Returns
  A string which shows the object's internal stuff.

Reimplemented in libdap::Sequence.

Definition at line 180 of file BaseType.cc.

## transfer_attributes()

void libdap::Constructor::transfer_attributes | ( | AttrTable * | at_container | ) |

override virtual

Transfer attributes from a DAS object into this variable. Because of the rough history of the DAS object and the way that various server code built the DAS, this is necessarily a heuristic process. The intent is that this method will be overridden by handlers that need to look for certain patterns in the DAS (e.g., hdf4's odd variable_dim_n; where n = 0, 1, 2, ...) attribute containers.

There should be a one-to-one mapping between variables and attribute containers. However, in some cases one variable has attributes spread across several top level containers and in some cases one container is used by several variables

Note
  This method is technically unnecessary because a server (or client) can easily add attributes directly using the DDS::get_attr_table or BaseType::get_attr_table methods and then poke values in using any of the methods AttrTable provides. This method exists to ease the transition to DDS objects which contain attribute information for the existing servers (Since they all make DAS objects separately from the DDS). They could be modified to use the same AttrTable methods but operate on the AttrTable instances in a DDS/BaseType instead of those in a DAS.

Parameters

  at_container | Transfer attributes from this container.

Returns
  void

Reimplemented from libdap::BaseType.

Reimplemented in libdap::Grid.

Definition at line 761 of file Constructor.cc.

## transform_to_dap2()

std::vector< BaseType * > * libdap::BaseType::transform_to_dap2 | ( | AttrTable * | parent_attr_table | ) |

virtual inherited

DAP4 to DAP2 transform.

For the current BaseType, return a DAP2 'copy' of the variable.

Note
  For most DAP4 types, in this implementation of DAP2 the corresponding DAP4 type is the same. These types have a different representations in DAP2 and DAP4: Sequences (which are D4Sequences in the DAP4 implementation),
  - Grids (which are semantically subsumed by coverages in DAP4)
  - Arrays (which use shared dimensions in DAP4)

Additionally DAP4 adds the following types:

- UInt8, Int8, and Char which map to Byte in DAP2.
- Int64, Unit64 which have no natural representation in DAP2.
- Opaque Possible Byte stuff[] plus metadata?
- Enum's can be represented as Int32.
- Groups, with the exception of the root group "disappear" into the names of their member variables. Specifically the Group name is add as a prefix followed by a "/" separator to the names of all of the Group's member groups variables.

Parameters

  The | AttrTable pointer parent_attr_table is used by Groups, which disappear from the DAP2 representation. Their children are returned in the the BAseType vector their attributes are added to parent_attr_table;

Returns
  A pointer to a vector of BaseType pointers (right?). In most cases this vector will contain a single pointer but DAP4 types 'disappear' such as Group will return all of their member variables in the vector. DAP4 types with no representation in DAP2 (ex: UInt64) the will return a NULL pointer and so this must be tested!

Reimplemented in libdap::Structure, libdap::Array, libdap::Byte, libdap::D4Enum, libdap::D4Group, libdap::D4Opaque, libdap::Int64, libdap::Int8, and libdap::UInt64.

Definition at line 255 of file BaseType.cc.

## transform_to_dap4()

void libdap::Constructor::transform_to_dap4 | ( | D4Group * | root,
|  | Constructor * | container
| ) |  |

override virtual

DAP2 to DAP4 transform.

For the current BaseType, return a DAP4 'copy' of the variable.

Note
  For most DAP2 types, in this implementation of DAP4 the corresponding DAP4 type is the same. The different types are Sequences (which are D4Sequences in the DAP4 implementation), Grids (which are coverages) and Arrays (which use shared dimensions).

Parameters

  root | The root group that should hold this new variable. Add Group-level stuff here (e.g., D4Dimensions).
  container | Add the new variable to this container.

Returns
  A pointer to the transformed variable

Reimplemented from libdap::BaseType.

Reimplemented in libdap::Grid, libdap::Sequence, and libdap::Structure.

Definition at line 85 of file Constructor.cc.

## type()

Type libdap::BaseType::type | ( |  | ) | const

virtual inherited

Returns the type of the class instance.

Definition at line 362 of file BaseType.cc.

## type_name()

string libdap::BaseType::type_name | ( |  | ) | const

virtual inherited

Returns the type of the class instance as a string.

Definition at line 376 of file BaseType.cc.

## val2buf()

unsigned int libdap::Constructor::val2buf | ( | void * | val,
|  | bool | reuse
| ) |  |

inline override virtual

Loads class data.

Store the value pointed to by val in the object's internal buffer. This function does not perform any checks, so users must be sure that the thing pointed to can actually be stored in the object's buffer.

Only simple objects (Int, Float, Byte, and so on) and arrays of these simple objects may be stored using this function. To put data into more complex constructor types, use the functions provided by that class.

Deprecated:
  Use set_value() in the leaf classes.

Parameters

  val | A pointer to the data to be inserted into the class data buffer.
  reuse | A boolean value, indicating whether the class internal data storage can be reused or not. If this argument is TRUE, the class buffer is assumed to be large enough to hold the incoming data, and it is not reallocated. If FALSE, new storage is allocated. If the internal buffer has not been allocated at all, this argument has no effect. This is currently used only in the Vector class.

Returns
  The size (in bytes) of the information copied from val.

See also
  Grid
  Vector::val2buf

Implements libdap::BaseType.

Definition at line 139 of file Constructor.h.

## var() [1/2]

BaseType * libdap::Constructor::var | ( | const string & | n,
|  | btp_stack & | s
| ) |  |

override virtual

btp_stack no longer needed; use back pointers (BaseType::get_parent())

Deprecated:

Deprecated:
  See comment in BaseType

Reimplemented from libdap::BaseType.

Definition at line 222 of file Constructor.cc.

## var() [2/2]

BaseType * libdap::Constructor::var | ( | const string & | name,
|  | bool | exact_match = `true`,
|  | btp_stack * | s = `nullptr`
| ) |  |

override virtual

btp_stack no longer needed; use back pointers (BaseType::get_parent())

Reimplemented from libdap::BaseType.

Definition at line 210 of file Constructor.cc.

## var_begin()

Constructor::Vars_iter libdap::Constructor::var_begin | ( |  | ) |

Returns an iterator referencing the first structure element.

Definition at line 297 of file Constructor.cc.

## var_end()

Constructor::Vars_iter libdap::Constructor::var_end | ( |  | ) |

Returns an iterator referencing the end of the list of structure elements. Does not reference the last structure element.

Definition at line 305 of file Constructor.cc.

## var_rbegin()

Constructor::Vars_riter libdap::Constructor::var_rbegin | ( |  | ) |

Return a reverse iterator that references the last element.

Definition at line 312 of file Constructor.cc.

## var_rend()

Constructor::Vars_riter libdap::Constructor::var_rend | ( |  | ) |

Return a reverse iterator that references a point 'before' the first element.

Definition at line 320 of file Constructor.cc.

## variables()

const vector< BaseType * > & libdap::Constructor::variables | ( |  | ) | const

inline

Get a const reference to the vector of BaseType pointers.

Note
  Use this in range-based for loops to iterate over the variables.

Returns
  A const reference to the vector of BaseType pointers.

Definition at line 115 of file Constructor.h.

## width()

unsigned int libdap::Constructor::width | ( | bool | constrained = `false` | ) | const

override virtual

This version of width simply returns the same thing as width() for simple types and Arrays. For Structure it returns the total size if constrained is false, or the size of the elements in the current projection if true.

Parameters

  constrained | If true, return the size after applying a constraint.

Returns
  The number of bytes used by the variable.

Deprecated:
  Use width_ll()

Reimplemented from libdap::BaseType.

Definition at line 169 of file Constructor.cc.

## width_ll()

int64_t libdap::Constructor::width_ll | ( | bool | constrained = `false` | ) | const

override virtual

Get the width of the Constructor's fields.

Parameters

  constrained | If true, return the constrained size

Returns
  The number of bytes needed to store the values of this instance

Reimplemented from libdap::BaseType.

Definition at line 192 of file Constructor.cc.

## Member Data Documentation

## d_vars

std::vector<BaseType *> libdap::Constructor::d_vars

protected

Definition at line 49 of file Constructor.h.

The documentation for this class was generated from the following files:

- Constructor.h
- Constructor.cc